#include <wiringPi.h>
#include <wiringPiI2C.h>
#include <stdio.h>
#include <stdlib.h> // system
// g++ -Wall ir01.c -o ir01 -lwiringPi

void gotoxy(int x,int y){
    printf("%c[%d;%df",0x1B,y,x);
    fflush(stdout);
}

unsigned char byIR(){
    int fd; 
    
    fd = wiringPiI2CSetup(0x39);
    
	return wiringPiI2CRead(fd);
}

void vIR(bool *bBR,bool *bBL,bool *bFSL,bool *bFL,bool *bFC,bool *bFR,bool *bFSR){
	unsigned char byIr = byIR();
	
	*bBR = byIr & 0x01;
	*bBL = (byIr >> 1) & 0x01;
	*bFSL = (byIr >> 2) & 0x01;
	*bFL = (byIr >> 3) & 0x01;
	*bFC = (byIr >> 4) & 0x01;
	*bFR = (byIr >> 5) & 0x01;
	*bFSR = (byIr >> 6) & 0x01;
}

void vShowIR(bool bBR,bool bBL,bool bFSL,bool bFL,bool bFC,bool bFR,bool bFSR){
  char sz[33];

  gotoxy(1,1);
  printf(" /----/^\\----\\\n");
  sprintf(sz,    " |%c  %c %c %c  %c|",bFSL?'W':'B',bFL?'W':'B',bFC?'W':'B',bFR?'W':'B',bFSR?'W':'B');printf("%s\n",sz);
  printf("[ ]    ^    [ ]\n");
  //sprintf(sz,    "[ ]    %c    [ ]",digitalRead(BUTTON_START) ? 'N':'P');printf("%s\n",sz);
  printf(" |     ^     |\n");
  printf("[ ]    ^    [ ]\n");
  printf("[ ]    ^    [ ]\n");
  sprintf(sz," |%c    ^    %c|",bBL?'W':'B',bBR?'W':'B');printf("%s\n",sz);
  printf(" +-----------+\n");
}

int main (){
    bool bBR, bBL, bFSL, bFL, bFC, bFR, bFSR;

	system("clear");
    wiringPiSetup();

	while(1){
		vIR(&bBR, &bBL, &bFSL, &bFL, &bFC, &bFR, &bFSR);
		vShowIR(bBR, bBL, bFSL, bFL, bFC, bFR, bFSR);
		delay(100);
	}

    return 0;
}
