#!/usr/bin/python3
# -*- coding: utf-8 -*-

# ir02.py

from smbus import SMBus
import time,os 

def byIR():
	global ir
	
	ucB = ir.read_byte(0x39)
	
	return ucB	

def bySensors():
	byIr = byIR()
	
	bBR = byIr & 0x01
	bBL = (byIr >> 1) & 0x01
	bFSL = (byIr >> 2) & 0x01
	bFL = (byIr >> 3) & 0x01
	bFC = (byIr >> 4) & 0x01
	bFR = (byIr >> 5) & 0x01
	bFSR = (byIr >> 6) & 0x01
	
	return [bBR,bBL,bFSL,bFL,bFC,bFR,bFSR]

def vShowIR():
	bBR,bBL,bFSL,bFL,bFC,bFR,bFSR = bySensors()
	
	gotoxy(1,1);
	print(" /----/^\\----\\");
	print(" |%c  %c %c %c  %c|"%('W' if bFSL else 'B','W' if bFL else 'B','W' if bFC else 'B','W' if bFR else 'B','W' if bFSR else 'B'))
	print("[ ]    ^    [ ]");
	#print("[ ]    %c    [ ]",'N' if digitalRead(BUTTON_START) else'P')
	print(" |     ^     |");
	print("[ ]    ^    [ ]");
	print("[ ]    ^    [ ]");
	print(" |%c    ^    %c|"%('W' if bBL else'B','W' if bBR else 'B'))
	print(" +-----------+");


def gotoxy(x,y):
	print ("%c[%d;%df" % (0x1B, y, x), end='') 

def setup():
	global ir
	
	os.system("clear")
	ir = SMBus(1)

def main():
	try:
		while True:
			#gotoxy(1,1)
			#print("Reading byte at 0x39 address: 0x%X"%byIR())
			vShowIR()
			time.sleep(0.1) 
			
	except KeyboardInterrupt:
		print ("\nSortint ...")

setup()
main()
