#!/usr/bin/python3
# -*- coding: utf-8 -*-

# irUs_01.py

from smbus import SMBus
import time,os 
import RPi.GPIO as GPIO

def byIR():
	global ir
	
	ucB = ir.read_byte(0x39)
	
	return ucB	

def bySensors():
	byIr = byIR()
	
	bBR = byIr & 0x01
	bBL = (byIr >> 1) & 0x01
	bFSL = (byIr >> 2) & 0x01
	bFL = (byIr >> 3) & 0x01
	bFC = (byIr >> 4) & 0x01
	bFR = (byIr >> 5) & 0x01
	bFSR = (byIr >> 6) & 0x01
	
	return [bBR,bBL,bFSL,bFL,bFC,bFR,bFSR]

def digitalRead(nPin):
	return GPIO.input(nPin)

def vShowIR():
	global BUTTON_START
	bBR,bBL,bFSL,bFL,bFC,bFR,bFSR = bySensors()
	
	gotoxy(1,1);
	print("  { d: %d cm }            "%nUltrasonicCm() )
	print(" /----/^\\----\\");
	print(" |%c  %c %c %c  %c|"%('W' if bFSL else 'B','W' if bFL else 'B','W' if bFC else 'B','W' if bFR else 'B','W' if bFSR else 'B'))
	print("[ ]    ^    [ ]");
	print("[ ]    %c    [ ]"%('N' if digitalRead(BUTTON_START) else'P'))
	print(" |     ^     |");
	print("[ ]    ^    [ ]");
	print("[ ]    ^    [ ]");
	print(" |%c    ^    %c|"%('W' if bBL else'B','W' if bBR else 'B'))
	print(" +-----------+");


def gotoxy(x,y):
	print ("%c[%d;%df" % (0x1B, y, x), end='') 

def nUltrasonicCm():
	global TRIG,ECHO
	
	GPIO.output(TRIG, True)                  #Set TRIG as HIGH
	time.sleep(0.00001)                      #Delay of 0.00001 seconds
	GPIO.output(TRIG, False)                 #Set TRIG as LOW

	while GPIO.input(ECHO)==0:               #Check whether the ECHO is LOW
		pulse_start = time.time()              #Saves the last known time of LOW pulse

	while GPIO.input(ECHO)==1:               #Check whether the ECHO is HIGH
		pulse_end = time.time()                #Saves the last known time of HIGH pulse 

	pulse_duration = pulse_end - pulse_start #Get pulse duration to a variable

	distance = pulse_duration * 17150        #Multiply pulse duration by 17150 to get distance
	distance = round(distance, 2)            #Round to two decimal points

	return distance

if __name__ == "__main__":
	def setup():
		global ir,BUTTON_START,TRIG,ECHO
		
		BUTTON_START = 17
		os.system("clear")
		ir = SMBus(1)
		GPIO.setwarnings(False)
		GPIO.setmode(GPIO.BCM)
		GPIO.setup(BUTTON_START,GPIO.IN,pull_up_down=GPIO.PUD_UP)
		TRIG = 5                                   #Associate pin 5 to TRIG
		ECHO = 6                                   #Associate pin 6 to ECHO
		GPIO.setup(TRIG,GPIO.OUT)                  #Set pin as GPIO out
		GPIO.setup(ECHO,GPIO.IN)                   #Set pin as GPIO in
		GPIO.output(TRIG, False)                   #Set TRIG as LOW
		
	def main():
		try:
			while True:
				vShowIR()
				time.sleep(0.1) 
				
		except KeyboardInterrupt:
			os.system("clear")
			print ("\nSortint ...")

	setup()
	main()
