#!/usr/bin/python3
# -*- coding: utf-8 -*-

# https://electrosome.com/hc-sr04-ultrasonic-sensor-raspberry-pi/

import RPi.GPIO as GPIO                    #Import GPIO library
import time,os                             #Import time & os libraries

def setup():
	global TRIG,ECHO
	
	os.system("clear")
	GPIO.setwarnings(False)
	GPIO.setmode(GPIO.BCM)                     #Set GPIO pin numbering 
	TRIG = 5                                   #Associate pin 5 to TRIG
	ECHO = 6                                   #Associate pin 6 to ECHO
	GPIO.setup(TRIG,GPIO.OUT)                  #Set pin as GPIO out
	GPIO.setup(ECHO,GPIO.IN)                   #Set pin as GPIO in
	GPIO.output(TRIG, False)                   #Set TRIG as LOW

def gotoxy(x,y):
	print ("%c[%d;%df" % (0x1B, y, x), end='') 

def nUltrasonicCm():
  GPIO.output(TRIG, True)                  #Set TRIG as HIGH
  time.sleep(0.00001)                      #Delay of 0.00001 seconds
  GPIO.output(TRIG, False)                 #Set TRIG as LOW

  while GPIO.input(ECHO)==0:               #Check whether the ECHO is LOW
    pulse_start = time.time()              #Saves the last known time of LOW pulse

  while GPIO.input(ECHO)==1:               #Check whether the ECHO is HIGH
    pulse_end = time.time()                #Saves the last known time of HIGH pulse 

  pulse_duration = pulse_end - pulse_start #Get pulse duration to a variable

  distance = pulse_duration * 17150        #Multiply pulse duration by 17150 to get distance
  distance = round(distance, 2)            #Round to two decimal points

  return distance

def main():
	try:
		while True:
			gotoxy(1,1) 
			distance = nUltrasonicCm()
			if distance > 2 and distance < 400:      #Check whether the distance is within range
				print ("Distance:",distance - 0.5,"cm                                  ")  #Print distance with 0.5 cm calibration
			else:
				print ("Out Of Range")                   #display out of range	
			time.sleep(0.1)                            #Delay 

	except KeyboardInterrupt:
		print ("\nSortint ...")
		
setup()
main()



